Debian Bug report logs - #720327
ITP: ecp -- copies files with checksum on the fly"

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: root <eun@su.am>

Date: Tue, 20 Aug 2013 14:03:02 UTC

Owned by: Eun <eun@su.am>

Severity: wishlist

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org, wnpp@debian.org, Eun <eun@su.am>:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 14:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to root <eun@su.am>:
New Bug report received and forwarded. Copy sent to debian-devel@lists.debian.org, wnpp@debian.org, Eun <eun@su.am>. (Tue, 20 Aug 2013 14:03:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: root <eun@su.am>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 15:33:06 +0200
Package: wnpp
Severity: wishlist
Owner: Eun <eun@su.am>

* Package name    : esu
  Version         : 1.01
  Upstream Author : Eun <eun@su.am>
* URL             : https://github.com/Eun/ecp
* License         : GPLv3
  Programming Lang: C
  Description     : It allows to copy files with different checksums on the fly.

Basicly a replacement for cp with additional checksum on the fly support.
It allows MD5, SHA1, SHA224, SHA265, SHA384, SHA512 algorithm to be used.



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Eun <eun@su.am>:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 14:24:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ryan Kavanagh <rak@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Eun <eun@su.am>. (Tue, 20 Aug 2013 14:24:09 GMT) Full text and rfc822 format available.

Message #10 received at 720327@bugs.debian.org (full text, mbox):

From: Ryan Kavanagh <rak@debian.org>
To: debian-devel@lists.debian.org
Cc: 720327@bugs.debian.org
Subject: Re: Bug#720327: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 10:21:05 -0400
[Message part 1 (text/plain, inline)]
On Tue, Aug 20, 2013 at 03:33:06PM +0200, root wrote:
> * Package name    : esu
>   Description     : It allows to copy files with different checksums
>                     on the fly.
> 
> Basicly a replacement for cp with additional checksum on the fly
> support.  It allows MD5, SHA1, SHA224, SHA265, SHA384, SHA512
> algorithm to be used.

How is this different from rsync? Quoting rsync(1):

       Rsync is a fast and extraordinarily versatile file  copying
       tool.   It can  copy  locally,  to/from  another  host  over
       any remote shell, or to/from a remote rsync daemon.
       [...]
               -c, --checksum              skip based on checksum,
                                           not mod-time & size

Best wishes,
Ryan

-- 
|_)|_/	Ryan Kavanagh		| Debian Developer
| \| \	http://ryanak.ca/	| GPG Key 4A11C97A
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 14:30:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to Eun <eun@su.am>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Tue, 20 Aug 2013 14:30:14 GMT) Full text and rfc822 format available.

Message #15 received at 720327@bugs.debian.org (full text, mbox):

From: Eun <eun@su.am>
To: Ryan Kavanagh <rak@debian.org>, 720327@bugs.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#720327: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 16:29:00 +0200
[Message part 1 (text/plain, inline)]
The difference is that ecp generates the checksum on the fly, this means it
is faster then rsync,
rsync copy's first and compares the sum of the source and destination
afterwards (4 operations).
esu saves one operation by calculating the checksum during reading the file.

to make it clearer:

rsync:
1. read srcfile
2. write dstfile
3. checksum of src
4. checksum of dst

ecp:
1. read srcfile, checksum of src
2. write dstfile
3. checksum of dst



2013/8/20 Ryan Kavanagh <rak@debian.org>

> On Tue, Aug 20, 2013 at 03:33:06PM +0200, root wrote:
> > * Package name    : esu
> >   Description     : It allows to copy files with different checksums
> >                     on the fly.
> >
> > Basicly a replacement for cp with additional checksum on the fly
> > support.  It allows MD5, SHA1, SHA224, SHA265, SHA384, SHA512
> > algorithm to be used.
>
> How is this different from rsync? Quoting rsync(1):
>
>        Rsync is a fast and extraordinarily versatile file  copying
>        tool.   It can  copy  locally,  to/from  another  host  over
>        any remote shell, or to/from a remote rsync daemon.
>        [...]
>                -c, --checksum              skip based on checksum,
>                                            not mod-time & size
>
> Best wishes,
> Ryan
>
> --
> |_)|_/  Ryan Kavanagh           | Debian Developer
> | \| \  http://ryanak.ca/       | GPG Key 4A11C97A
>
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Eun <eun@su.am>:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 14:48:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Konstantin Khomoutov <flatworm@users.sourceforge.net>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Eun <eun@su.am>. (Tue, 20 Aug 2013 14:48:07 GMT) Full text and rfc822 format available.

Message #20 received at 720327@bugs.debian.org (full text, mbox):

From: Konstantin Khomoutov <flatworm@users.sourceforge.net>
To: root <eun@su.am>, 720327@bugs.debian.org
Subject: Re: Bug#720327: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 18:44:07 +0400
On Tue, 20 Aug 2013 15:33:06 +0200
root <eun@su.am> wrote:

> * Package name    : esu
[...]

The package name is also very unfortunate: there's a ubiquitous tool,
called `su`, which has nothing to do with copying files.  I suspect the
name of this tools will provoke unnecessary confusion with `su`.

So my take on the tool's name would be to name it `cscp` (for "checksum
cp").  At least the archive does not seem to contain a binary named
like this [1].

1. http://packages.debian.org/search?searchon=contents&keywords=cscp&mode=path&suite=stable&arch=i386



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Eun <eun@su.am>:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 14:48:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Konstantin Khomoutov <flatworm@users.sourceforge.net>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Eun <eun@su.am>. (Tue, 20 Aug 2013 14:48:10 GMT) Full text and rfc822 format available.

Message #25 received at 720327@bugs.debian.org (full text, mbox):

From: Konstantin Khomoutov <flatworm@users.sourceforge.net>
To: root <eun@su.am>, 720327@bugs.debian.org
Subject: Re: Bug#720327: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 18:38:43 +0400
On Tue, 20 Aug 2013 15:33:06 +0200
root <eun@su.am> wrote:

> * Package name    : esu

I would rephrase both fields a bit, as follows.

>   Description     : It allows to copy files with different checksums
> on the fly.

"Copies a file calculating its checksum on the fly and printing it after
copying is completed."

> Basicly

^^^ Basically.

> a replacement for cp with additional checksum on the fly
> support. It allows MD5, SHA1, SHA224, SHA265, SHA384, SHA512
> algorithm to be used.

I did not dive into the tool's source code but I doubt it's really a
replacement for GNU `cp` is a complex tool with wide range of
possibilities such as:
* Copying whole hierarchies.
* Conditional file replacement -- only when the source file is newer
  ("updating");
* Preserving ownership and permissions.
* Copying (or not copying) of special files (such as FIFOs).
* Creating backups of the replaced files.
* Hardlinking instead of copying (including processing whole
  hierarchies).

So I would rephrase the description into something like this:
"This tools allows to copy one or more files calculating their checksum
on the fly as it transfers their data.  The checksums are printed to
the standard output.
.
The following checksumming algorythms are supported: MD5, SHA1...".

Hope this helps.

P.S.
On the tool's web page, in the "Usage" section, consider changing the
"-d               create empty directorys"
line to read
"-d               create empty directories"
as there's a common rule in English.



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Eun <eun@su.am>:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 14:48:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Konstantin Khomoutov <flatworm@users.sourceforge.net>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Eun <eun@su.am>. (Tue, 20 Aug 2013 14:48:13 GMT) Full text and rfc822 format available.

Message #30 received at 720327@bugs.debian.org (full text, mbox):

From: Konstantin Khomoutov <flatworm@users.sourceforge.net>
To: Ryan Kavanagh <rak@debian.org>
Cc: debian-devel@lists.debian.org, 720327@bugs.debian.org
Subject: Re: Bug#720327: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 18:41:22 +0400
On Tue, 20 Aug 2013 10:21:05 -0400
Ryan Kavanagh <rak@debian.org> wrote:

> On Tue, Aug 20, 2013 at 03:33:06PM +0200, root wrote:
> > * Package name    : esu
> >   Description     : It allows to copy files with different checksums
> >                     on the fly.
> > 
> > Basicly a replacement for cp with additional checksum on the fly
> > support.  It allows MD5, SHA1, SHA224, SHA265, SHA384, SHA512
> > algorithm to be used.
> 
> How is this different from rsync? Quoting rsync(1):
> 
>        Rsync is a fast and extraordinarily versatile file  copying
>        tool.   It can  copy  locally,  to/from  another  host  over
>        any remote shell, or to/from a remote rsync daemon.
>        [...]
>                -c, --checksum              skip based on checksum,
>                                            not mod-time & size

It means "do not copy a file if its checksum on the receiver is the
same as on the sender", that is, this option just modifies the way
`rsync` detects whether a particular file should be updated on the
receiver.  The proposed tool combines (unconditional) copying with
calculating a checksum over the copied content.  At least that's how I
read it.



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Eun <eun@su.am>:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 15:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Lars Wirzenius <liw@liw.fi>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Eun <eun@su.am>. (Tue, 20 Aug 2013 15:21:04 GMT) Full text and rfc822 format available.

Message #35 received at 720327@bugs.debian.org (full text, mbox):

From: Lars Wirzenius <liw@liw.fi>
To: debian-devel@lists.debian.org, 720327@bugs.debian.org
Subject: Re: Bug#720327: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 16:09:40 +0100
On Tue, Aug 20, 2013 at 06:41:22PM +0400, Konstantin Khomoutov wrote:
> On Tue, 20 Aug 2013 10:21:05 -0400
> Ryan Kavanagh <rak@debian.org> wrote:
> 
> > On Tue, Aug 20, 2013 at 03:33:06PM +0200, root wrote:
> > > * Package name    : esu
> > >   Description     : It allows to copy files with different checksums
> > >                     on the fly.
> > > 
> > > Basicly a replacement for cp with additional checksum on the fly
> > > support.  It allows MD5, SHA1, SHA224, SHA265, SHA384, SHA512
> > > algorithm to be used.
> > 
> > How is this different from rsync? Quoting rsync(1):
...
> [discussion of meaning of rsync option]

It would be helpful if the upstream README.md and the package description
explain what the checksums are for. Is this a replacement for cp+sha1sum
(or sha256sum or whatever algorithm is used), or is the checksum used
for verifying that the resulting file is copied correctly and has not
become corrupted during the copy? If the latter, does the program do
anything else to ensure a safe copy, such as fsync to make sure the
target file is committed to disk, or flushing kernel buffer caches so
that checksumming the target file happens on data that is read from the
target disk, and not from cache memory? Also an explanation of why this
is useful and why (and when) the kernel's usual mechanisms aren't enough
would be a good idea.

"cp, but with checksums" isn't a useful description of a program. Unless
the program's output includes the checksums (perhaps for later
verification), the checksums don't seem interesting to me as a user. They
seem like an implementation detail rather than an essential feature of
the program.

-- 
http://www.cafepress.com/trunktees -- geeky funny T-shirts
http://gtdfh.branchable.com/ -- GTD for hackers



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#720327; Package wnpp. (Tue, 20 Aug 2013 16:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Eun <eun@su.am>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Tue, 20 Aug 2013 16:42:03 GMT) Full text and rfc822 format available.

Message #40 received at 720327@bugs.debian.org (full text, mbox):

From: Eun <eun@su.am>
To: 720327 <720327@bugs.debian.org>
Cc: debian-devel <debian-devel@lists.debian.org>
Subject: Re: Bug#720327: ITP: esu -- It allows to copy files with different checksums on the fly.
Date: Tue, 20 Aug 2013 18:38:12 +0200
[Message part 1 (text/plain, inline)]
Package name should be "ecp", sorry misspelled that.

I fixed the README and improved some things.

Thanks for your feedback!


2013/8/20 Lars Wirzenius <liw@liw.fi>

> On Tue, Aug 20, 2013 at 06:41:22PM +0400, Konstantin Khomoutov wrote:
> > On Tue, 20 Aug 2013 10:21:05 -0400
> > Ryan Kavanagh <rak@debian.org> wrote:
> >
> > > On Tue, Aug 20, 2013 at 03:33:06PM +0200, root wrote:
> > > > * Package name    : esu
> > > >   Description     : It allows to copy files with different checksums
> > > >                     on the fly.
> > > >
> > > > Basicly a replacement for cp with additional checksum on the fly
> > > > support.  It allows MD5, SHA1, SHA224, SHA265, SHA384, SHA512
> > > > algorithm to be used.
> > >
> > > How is this different from rsync? Quoting rsync(1):
> ...
> > [discussion of meaning of rsync option]
>
> It would be helpful if the upstream README.md and the package description
> explain what the checksums are for. Is this a replacement for cp+sha1sum
> (or sha256sum or whatever algorithm is used), or is the checksum used
> for verifying that the resulting file is copied correctly and has not
> become corrupted during the copy? If the latter, does the program do
> anything else to ensure a safe copy, such as fsync to make sure the
> target file is committed to disk, or flushing kernel buffer caches so
> that checksumming the target file happens on data that is read from the
> target disk, and not from cache memory? Also an explanation of why this
> is useful and why (and when) the kernel's usual mechanisms aren't enough
> would be a good idea.
>
> "cp, but with checksums" isn't a useful description of a program. Unless
> the program's output includes the checksums (perhaps for later
> verification), the checksums don't seem interesting to me as a user. They
> seem like an implementation detail rather than an essential feature of
> the program.
>
> --
> http://www.cafepress.com/trunktees -- geeky funny T-shirts
> http://gtdfh.branchable.com/ -- GTD for hackers
>
[Message part 2 (text/html, inline)]

Changed Bug title to 'ecp - copies files with checksum on the fly' from 'ITP: esu -- It allows to copy files with different checksums on the fly.' Request was from Tobias <tobias@su.am> to control@bugs.debian.org. (Tue, 20 Aug 2013 16:51:11 GMT) Full text and rfc822 format available.

Changed Bug title to '[wnpp] ITP: ecp - copies files with checksum on the fly' from 'ecp - copies files with checksum on the fly' Request was from Tobias <tobias@su.am> to control@bugs.debian.org. (Tue, 20 Aug 2013 17:09:11 GMT) Full text and rfc822 format available.

Changed Bug title to '"[wnpp] ITP: ecp - copies files with checksum on the fly"' from '[wnpp] ITP: ecp - copies files with checksum on the fly' Request was from Tobias <tobias@su.am> to control@bugs.debian.org. (Tue, 20 Aug 2013 17:15:06 GMT) Full text and rfc822 format available.

Changed Bug title to 'ITP: ecp -- copies files with checksum on the fly"' from '"[wnpp] ITP: ecp - copies files with checksum on the fly"' Request was from Mònica Ramírez Arceda <monica@debian.org> to control@bugs.debian.org. (Sat, 24 Aug 2013 19:21:10 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 19:15:13 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.